2018 Multi-University Training Contest 3--Problem A. Ascending Rating--hdu--6319

Problem A. Ascending Rating

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 524288/524288 K (Java/Others)
Total Submission(s): 2019    Accepted Submission(s): 603

 

Problem Description

Before the start of contest, there are n ICPC contestants waiting in a long queue. They are labeled by 1 to n from left to right. It can be easily found that the i-th contestant's QodeForces rating is ai.
Little Q, the coach of Quailty Normal University, is bored to just watch them waiting in the queue. He starts to compare the rating of the contestants. He will pick a continous interval with length m, say [l,l+m−1], and then inspect each contestant from left to right. Initially, he will write down two numbers maxrating=−1and count=0. Everytime he meets a contestant k with strictly higher rating than maxrating, he will change maxrating to ak and count to count+1.
Little T is also a coach waiting for the contest. He knows Little Q is not good at counting, so he is wondering what are the correct final value of maxrating and count. Please write a program to figure out the answer.

Input

The first line of the input contains an integer T(1≤T≤2000), denoting the number of test cases.
In each test case, there are 7 integers n,m,k,p,q,r,MOD(1≤m,k≤n≤107,5≤p,q,r,MOD≤109) in the first line, denoting the number of contestants, the length of interval, and the parameters k,p,q,r,MOD.
In the next line, there are k integers a1,a2,...,ak(0≤ai≤109), denoting the rating of the first k contestants.
To reduce the large input, we will use the following generator. The numbers p,q,r and MOD are given initially. The values ai(k<i≤n) are then produced as follows :

ai=(p×ai−1+q×i+r)modMOD
It is guaranteed that ∑n≤7×107 and ∑k≤2×106.

Output

Since the output file may be very large, let's denote maxratingi and counti as the result of interval [i,i+m−1].
For each test case, you need to print a single line containing two integers A and B, where :


Note that ``⊕'' denotes binary XOR operation.

Sample Input

1

10 6 10 5 5 5 5

3 2 2 1 5 7 6 8 2 9

Sample Output

46 11

Source

2018 Multi-University Training Contest 3 

题意:

给你一个长度为n的序列,然后再给你一个长度为m的区间,然后这个区间从1移动到n-m+1位,让你求A与B,maxrating是编号为 i 的区间中的最大值,count是区间从1开始移动时,移动时遇到一个大于当前区间最大值的数,count便+1,⊕是异或运算符。

然后为了避免有大量的输入,题目只给你序列前K位,后面n-k位需要你用公式自己计算,记得单独开longlong!

题解:

这个题要用单调队列,先解释一下什么是单调队列。

单调队列中存的是一个区间的最大的一个递减序列的序号

比如数组  a[i]

i12345678
a[i]947681279

      

 

 

9加入队列 ,9

4加入队列 ,9 4

7加入队列, 这时要把队尾和7比较 比7小的抛出队列 然后再把7加入 所以是 9 7

6加入队列,9 7 6

8加入队列,9 8

#include<cstdio>
const int N=10000010;
int T,n,m,k,P,Q,R,MOD,i,a[N],q[N],h,t;
long long A,B;
int main() {
    scanf("%d",&T);
    while(T--) {
        scanf("%d%d%d%d%d%d%d",&n,&m,&k,&P,&Q,&R,&MOD);
        for(i=1; i<=k; i++)scanf("%d",&a[i]);
        for(i=k+1; i<=n; i++)a[i]=(1LL*P*a[i-1]+1LL*Q*i+R)%MOD;
        for(h=1,t=A=B=0,i=n; i; i--) {
            while(h<=t&&a[q[t]]<=a[i]) {
              //  printf("!!%d %d %d %d %d %d\n",t,q[t],a[q[t]],h,q[h,a[q[h]]]);
                t--;
            }
            q[++t]=i;
            if(i+m-1<=n) {
                while(q[h]>=i+m){
                 //   printf("@@%d %d %d %d %d %d\n",t,q[t],a[q[t]],h,q[h,a[q[h]]]);
                    h++;
                }
                A+=i^a[q[h]];
                B+=i^(t-h+1);
            }
        }
        printf("%lld %lld\n",A,B);
    }
}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值